POJ 3487 The Stable Marriage Problem

2023-11-07 21:32
文章标签 poj problem stable 3487 marriage

本文主要是介绍POJ 3487 The Stable Marriage Problem,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Description

The stable marriage problem consists of matching members of two
different sets according to the member’s preferences for the other
set’s members. The input for our problem consists of:

a set M of n males;
a set F of n females;
for each male and female we have a list of all the members of the opposite gender in order of preference (from the most preferable to

the least).

A marriage is a one-to-one mapping between males and females. A
marriage is called stable, if there is no pair (m, f) such that f ∈ F
prefers m ∈ M to her current partner and m prefers f over his current
partner. The stable marriage A is called male-optimal if there is no
other stable marriage B, where any male matches a female he prefers
more than the one assigned in A.

Given preferable lists of males and females, you must find the
male-optimal stable marriage.

Input

The first line gives you the number of tests. The first line of each
test case contains integer n (0 < n < 27). Next line describes n male
and n female names. Male name is a lowercase letter, female name is an
upper-case letter. Then go n lines, that describe preferable lists for
males. Next n lines describe preferable lists for females.

Output

For each test case find and print the pairs of the stable marriage,
which is male-optimal. The pairs in each test case must be printed in
lexicographical order of their male names as shown in sample output.
Output an empty line between test cases.

稳定婚姻问题。
每次没有女友的男生在所有没有拒绝过他的女生中找一个最喜欢的表白,然后每个女生在自己的现男友和所有表白自己的男生中选一个最喜欢的接受。如果接受的是新男生的话,自己的前男友就被甩了。
可以证明【虽然我不会】,这种方法一定可以得到解,得到的解一定是可行解,而且这一解在所有解中对男生最优,对女生最劣。

#include<cstdio>
#include<cstring>
#define M(a) memset(a,0,sizeof(a))
int mrk[30][30],frk[30][30],cs[30][30],wf[30],hs[30],n,mnm[30],fnm[30],mnb[30],fnb[30];
bool ref[30][30];
void init()
{char s[50];int i,j,k,x,y,z;M(mrk);M(frk);M(cs);M(wf);M(hs);M(ref);M(mnm);M(fnm);M(mnb);M(fnb);scanf("%d",&n);for (i=1;i<=n;i++){scanf("%s",s+1);mnm[i]=s[1]-'a'+1;mnb[s[1]-'a'+1]=i;}for (i=1;i<=n;i++){scanf("%s",s+1);fnm[i]=s[1]-'A'+1;fnb[s[1]-'A'+1]=i;}for (i=1;i<=n;i++){scanf("%s",s+1);x=mnb[s[1]-'a'+1];for (k=1;k<=n;k++)mrk[x][k]=fnb[s[k+2]-'A'+1];}for (i=1;i<=n;i++){scanf("%s",s+1);x=fnb[s[1]-'A'+1];for (k=1;k<=n;k++)frk[x][k]=mnb[s[k+2]-'a'+1];}
}
void solve()
{int i,j,k,x,y,z;bool b;while (1){b=0;M(cs);for (i=1;i<=n;i++)if (!wf[i]){b=1;for (j=1;j<=n;j++)if (!ref[i][mrk[i][j]]){cs[i][mrk[i][j]]=1;break;}}if (!b) return;for (i=1;i<=n;i++)for (j=1;j<=n;j++){if (cs[frk[i][j]][i]){wf[frk[i][j]]=i;if (hs[i]){wf[hs[i]]=0;ref[hs[i]][i]=1;}hs[i]=frk[i][j];break;}if (frk[i][j]==hs[i]) break;}for (i=1;i<=n;i++)for (j=1;j<=n;j++)if (cs[i][j]&&hs[j]!=i)ref[i][j]=1;}
}
void prt()
{int i,j,k;for (i=1;i<=26;i++)if (mnb[i])printf("%c %c\n",i+'a'-1,fnm[wf[mnb[i]]]+'A'-1);
}
int main()
{int T,i;scanf("%d",&T);while (T--){init();solve();prt();if (T) printf("\n");}
}

这篇关于POJ 3487 The Stable Marriage Problem的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/366396

相关文章

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一